# -*- coding: utf-8 -*-

"""
Module implementing MainWindow.
"""

from PyQt4.QtGui import QMainWindow
from PyQt4.QtCore import pyqtSignature
from PyQt4 import QtCore, QtGui
from Ui_fenetre import Ui_MainWindow

import re

class MainWindow(QMainWindow, Ui_MainWindow):
    """
    Class documentation goes here.
    """
    def __init__(self, parent = None):
        """
        Constructor
        """
        QMainWindow.__init__(self, parent)
        self.setupUi(self)
    
    @pyqtSignature("")
    def on_pushButton_clicked(self):
        """
        charger l'URL indiqué dans lineedit.
        """
        url = unicode(self.lineEdit.text())
        if not url.startswith("http://"): url="http://"+url
        self.webView.setUrl(QtCore.QUrl(url))
        self.statusbar.setText("En cours de chargement "+url)
    
    
    
    @pyqtSignature("")
    def on_lineEdit_returnPressed(self):
        """
        Slot documentation goes here.
        """
        self.on_pushButton_clicked()
    
    
    
    def on_webView_loadFinished (self):
        """
        quand le chargement est terminé.
        """
        self.statusbar.setText(unicode(self.webView.url().toString())+" Chargement termine")
        html = unicode(self.webView.page().mainFrame().toHtml())
        text = self.nettoie(html)
        self.textEdit.setText(text)
        langue = self.langue(text)
        self.label.setText(langue)
        
        
    def langue (self, text):
          
        langues = {"en":"anglais","de":"allemand","fr":u"français", "es":"espagnol","po":"portuguais", "it":"italien"} 
        dicoMots={} 
        resultat=[] 
        for langue in langues: 
            fichier = open("liste"+langue+".txt") 
            texte = fichier.read() 
            expr = re.compile("\W+", re.U) 
            liste = expr.split(texte) 
            dicoMots[langue]=liste 



        listeinc=text.split()
        for langue in langues:
            compteurmots=0
            for mot in listeinc:
                if mot in dicoMots[langue]: compteurmots+=1 
            resultat+=[(compteurmots,langue)]
        resultat.sort()

    
        return "Votre page est en : " + langues[resultat[-1][1]]+"."
    
    
    def nettoie (self, html):
        
        
        html = html.replace("\n", " ")
        expr = re.compile("<script.*?</script>",  re.U)
        html = expr.sub(" ",  html)
        expr = re.compile("<style.*?</style>",  re.U)
        html = expr.sub(" ",  html)
        expr = re.compile("<.*?>")
        text = expr.sub(" ",  html)
        text = text.replace("&nbsp;", " ")
        text = re.sub(" +", " ", text)
        return text



        
if __name__ == "__main__":
    
 import sys
 app = QtGui.QApplication(sys.argv)
 wnd = MainWindow()
 wnd.show()
 sys.exit(app.exec_())
    



  


